package com.seeyon.cap4.form.bean.fieldCtrl;

import com.seeyon.cap4.form.bean.FormFieldComEnum;
import com.seeyon.cap4.form.util.Enums.FieldType;

/**
 * Created by yangz on 2018/3/21.
 * 电子发票字段映射枚举
 */
public enum EinvoiceFieldType {
    EINVOICETYPE("FPLX", "发票类型", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    EINVOICESTATE("FPZT", "发票状态", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    EINVOICESIGN("ZJBZ", "真假标志", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    CHECKNUM("JYM", "校验码", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    EINVOICECODE("FPDM", "发票代码", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    EINVOICENUM("FPHM", "发票号码", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    RATEPAYERCODE("GMF_NSRSBH", "购买方纳税人识别号", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    BUYERNAME("GMF_MC", "购买方名称", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    BUYERADDRES("GMF_DZDH", "购方地址、电话", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    BUYERBANK("GMF_YHZH", "购方开户行及账号", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    SELLERNAME("XSF_MC", "销售方名称", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    SELLERADDRES("XSF_DZDH", "销方地址、电话", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    SELLERBANK("XSF_YHZH", "销方开户行及账号", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    SELLERRATEPAYERCODE("XSF_NSRSBH", "销售方纳税人识别号", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    REMARK("BZ", "备注", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXTAREA}),
    TOTALINVOICE("HJJE", "合计金额", FieldType.DECIMAL, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    VALOREMSUM("JSHJ", "价税合计", FieldType.DECIMAL, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    AMOUNTTAXSUM("HJSE", "合计税额", FieldType.DECIMAL, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    //TICKETHOLDER("KPR", "开票人", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    //PAYEE("SKR", "收款人", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    //AUDITOR("FHR", "复核人", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    COMPUTERNO("JQBH", "机器编号", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    CHECKRESULT("MS", "发票查验结果描述", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXT}),
    CIPHERTEXT("FP_MW", "发票密文", FieldType.VARCHAR, new FormFieldComEnum[]{FormFieldComEnum.TEXTAREA}),
    INVOICEDATE("KPRQ", "开票日期", FieldType.TIMESTAMP, new FormFieldComEnum[]{FormFieldComEnum.EXTEND_DATE});


    EinvoiceFieldType(String key, String fieldName, FieldType fieldType, FormFieldComEnum[] supportFieldType) {
        this.key = key;
        this.fieldName = fieldName;
        this.fieldType = fieldType;
        this.supportFieldType = supportFieldType;
    }

    private String key;
    private String fieldName;
    private FieldType fieldType;
    private FormFieldComEnum[] supportFieldType;


    public String getKey() {
        return key;
    }

    public String getText() {
        return fieldName;
    }

    public FormFieldComEnum[] getSupportFieldType() {
        return supportFieldType;
    }

    public FieldType getFieldType() {
        return fieldType;
    }


    public static EinvoiceFieldType getEnumByKey(String key) {
        for (EinvoiceFieldType type : values()) {
            if (type.getKey().equals(key)) {
                return type;
            }
        }

        return null;
    }

    public static boolean isFieldCanBeChoose(String inputType) {
        boolean result = false;
        for (EinvoiceFieldType type : values()) {
            FormFieldComEnum[] comEnums = type.getSupportFieldType();
            for (FormFieldComEnum comEnum : comEnums) {
                if (comEnum.getKey().equalsIgnoreCase(inputType)) {
                    result = true;
                    break;
                }
            }
            if (result) {
                break;
            }
        }
        return result;
    }
}
